<?php

namespace app\common\model\score;

use app\common\model\BaseModel;
use think\Model;
use traits\model\SoftDelete;

class Event extends BaseModel
{

    use SoftDelete;

    

    // 表名
    protected $name = 'score_event';
    
    // 自动写入时间戳字段
    protected $autoWriteTimestamp = 'integer';

    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = 'updatetime';
    protected $deleteTime = 'deletetime';

    // 追加属性
    protected $append = [
        'status_text',
        'frequency_text',
        'way_text'
    ];
    

    protected static function init()
    {
        self::afterInsert(function ($row) {
            if (!$row['weigh']) {
                $pk = $row->getPk();
                $row->getQuery()->where($pk, $row[$pk])->update(['weigh' => $row[$pk]]);
            }
        });
    }

    
    public function getStatusList()
    {
        return config("site.type_point_program");
    }

    public function getFrequencyList()
    {
        return ['month' => __('Frequency month'), 'day' => __('Frequency day'), 'week' => __('Frequency week'), 'once' => __('Frequency once')];
    }

    public function getWayList()
    {
        return ['free' => __('Way free'), 'direct' => __('Way direct')];
    }


    public function getStatusTextAttr($value, $data)
    {
        $value = $value ?: ($data['status'] ?? '');
        $list = $this->getStatusList();
        return $list[$value] ?? '';
    }


    public function getFrequencyTextAttr($value, $data)
    {
        $value = $value ?: ($data['frequency'] ?? '');
        $list = $this->getFrequencyList();
        return $list[$value] ?? '';
    }


    public function getWayTextAttr($value, $data)
    {
        $value = $value ?: ($data['way'] ?? '');
        $valueArr = explode(',', $value);
        $list = $this->getWayList();
        return implode(',', array_intersect_key($list, array_flip($valueArr)));
    }

    protected function setWayAttr($value)
    {
        return is_array($value) ? implode(',', $value) : $value;
    }





    /**得到基础条件
     * @param $status
     * @param null $model
     * @param string $alisa
     */
    public static function getBaseWhere($whereData = [], $model = null, $alisa = '',$with = false)
    {

        if (!$model) {
            $model = new static;
            if ($alisa&&!$with) $model = $model->alias($alisa);
        }
        if ($alisa) $alisa = $alisa . '.';
        $tableFields = (new static)->getTableFields();
        foreach ($tableFields as $fields)
        {
            if(in_array($fields, ['way']))continue;
//            if (isset($whereData[$fields]) && $whereData[$fields]) $model = $model->where("{$alisa}{$fields}", '=', $whereData[$fields]);

            if (isset($whereData[$fields]) && $whereData[$fields]){
                if(is_array($whereData[$fields])){
                    $model = $model->where("{$alisa}{$fields}", $whereData[$fields][0], $whereData[$fields][1]);
                }else{
                    $model = $model->where("{$alisa}{$fields}", '=', $whereData[$fields]);
                }

            }


        }



        if (isset($whereData['keywords'])&&$whereData['keywords']){
            $model = $model->where("{$alisa}event_name|{$alisa}name|{$alisa}desc", 'LIKE', "%{$whereData['keywords']}%" );
        }

        if (isset($whereData['way']) && $whereData['way']!=="" && $whereData['way']!==null){
            //针对set数据字段，用find_in_set查询
            $way =  implode("|",explode(',',$whereData['way']));
            $model = $model->whereRaw(" {$alisa}way REGEXP '({$way})'");
        }



        if (isset($whereData['time'])&&$whereData['time']){

            $model = $model->time(["{$alisa}createtime",$whereData['time']]);
        }

//        if (isset($whereData['has_evaluate'])&&$whereData['has_evaluate']){
//            //1查已评价 2查未评价
//            if($whereData['has_evaluate'] == 1){
//                //1查已评价
//                $model = $model->where("{$alisa}classes_evaluate_id", '<>', 0);
//            }else{
//                //2查未评价
//                $model = $model->whereExists(function ($query) use ($alisa) {
//                    $order_table_name = (new \app\common\model\school\classes\hourorder\Order())->getQuery()->getTable();
//                    $query->table($order_table_name)->where($order_table_name . '.classes_order_id=' . $alisa . 'id')->where('status', '=', '3');
//                })->where("{$alisa}classes_evaluate_id", '=', 0);
//
//            }
//        }

        return $model;
    }






    public static function allList($page, $limit,$keywords,$way="",$params=[]){
        $with_field = [
//            'cate'=>['image','name'],
            'base'=>['*'],
        ];


//        $alisa = (new self)->getWithAlisaName();
//        $sort = "{$alisa}.weigh desc,{$alisa}.id desc";


        $sort = "weigh desc,id desc";
        $serch_where = ['way'=>$way,'keywords'=>$keywords];

        return (new self)->getBaseList(array_merge($serch_where,$params), $page, $limit,$sort,$with_field);
    }



}
